package com.eactive.eai.batch.job.jobItem.kfb;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_KFB0300 extends DefaultTelegram implements TelegramService {

    private int     SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int     REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이
    private int     MISSING_COUNT;     //결번갯수
    private String  MISSING_FIELD;

    private Properties telegramInfo;
    private File file;
    private FileOutputStream fout;

    /**
     * 생성자
     */
    public SEND_KFB0300() {
        //결번확인통보
        MISSING_COUNT = 0;
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            boolean result = calculateMissingCount();
            if (!result) return false;

            result = calculateSendLength();
            if (!result) return false;

            // 해당 Transaction을 기동하는 코드로 본 파일전송 업무는 “KFBFTP”문자를 사용한다.
            compileField(0, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[0]);

            //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
            compileField(1, ""+SEND_LENGTH, this.al_FieldProps[1]);
            
            //업무구분코드 -업무구분을 위하여 Set하는 문자로 본 파일전송 업무에서는 “FTP”문자를 사용키로 한다.
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);
            
            //대표기관코드 - 전문관련 금융기관을 나타내는 코드로서 금융기관 공동코드 (7자리)중 상위 3자리 금융기관 대표코드를 사용한다.
            // Ex) 국민: 004, 부산: 032, 농협: 011 등
            compileField(3, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[3]);
            
            //전문종별코드. 전문의 기능을 나타내는 구분코드로 전문종류별로 해당 전문코드를 Set하며 세부사항은 표준화 사항의 전문종별 코드를 참조한다.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);
            
            //거래구분코드 
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //송수신 FLAG 전문을 발생시킨 기관을 나타내는 코드로 아래의 값중 해당코드를 Set한다.
            //“C”: 은행연합회에서 전문을 발생할 시
            //“B”: 은행에서 전문을 발생할 시
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[6]);
            
            //응답코드
            compileField(7, TelegramKeys.KFB_RET_CODE_SUCCESS, this.al_FieldProps[7]);
            
            //전송기준일자
            compileField(8, batchDoc.getBatchMsg().getHeader().getBaseDate(), this.al_FieldProps[8]);
            
            //업무별 Record Length -송수신을 하고자 하는 자료의 Record Length를 Set 한다.
            // --받은 내용을 그대로 돌려 보내기
            compileField(9, ""+batchDoc.getBatchMsg().getHeader().getRecLen(), this.al_FieldProps[9]);
            
            //송수신 업무 구분코드. 은행연합회를 기준으로 하여 해당전문이 송수신업무 중 어느 업무에 관련된 것인지를 구분하기 위한 코드로 아래 값 중 해당코드를 Set한다.
            //“S”: 파일 송신업무 관련 전문 (은행연합회 → 은행)
            //“R”: 파일 수신업무 관련 전문 (은행 → 은행연합회)
            compileField(10, getFldTrClass() , this.al_FieldProps[10]);

            //Block-NO
            compileField(11, ""+this.batchDoc.getBatchMsg().getBody().getBlockNum(), this.al_FieldProps[11]);

            //Sequence-NO
            compileField(12, ""+this.batchDoc.getBatchMsg().getBody().getSeqNum(), this.al_FieldProps[12]);

            //결번갯수
            compileField(13, ""+MISSING_COUNT, this.al_FieldProps[11]);

            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }



    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

            if (MISSING_COUNT==0) {
                fout.close();
            }
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<10; i++) { //은행연합회 전문의 헤더는 레코드 길이까지 임.
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=10; i< al_Field.size(); i++) {  //결번확인 필드는 비정형 필드로 바디 로그에서 제외
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }


    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정형 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
            	logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
               return MISSING_FIELD.length();
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * return value : 0 no left data to be sent
     *                -1 error
     *                >0 data copied to the data field
     *
     * 비정형 필드인 결번확인의 데이터를 얻어낸다.
     * 결번확인 데이터를 실어주고 결번확인 필드의 길이를 반환한다.
     */
    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
            	logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < MISSING_FIELD.length()) {
            	logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            ByteArrayInputStream bin = new ByteArrayInputStream(MISSING_FIELD.getBytes());
            bin.read(data, 0, MISSING_FIELD.length());
            return MISSING_FIELD.length();
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=2; i< this.al_Field.size()-1; i++) { //마지막 결번확인은 가변길이
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += MISSING_FIELD.length();  //비정형 필드인 결번확인의 길이 더함.
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i < 2 ; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

        return true;
    }

    private boolean calculateMissingCount () {
        try {
            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            int seq_no  = this.batchDoc.getBatchMsg().getBody().getSeqNum();

            JobProcessData job = JobProcessData.getInstance();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

            byte[] _missingNm = new byte[seq_no];
            for (int i=0; i<seq_no; i++) {
                _missingNm[i] = '1';    //모든 결번은 1로 초기화
            }

            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>)hm.get(JobProcessData.PROCDATA_BLOCKDATA);

            if (block_data == null ){
                MISSING_COUNT = seq_no;
                for (int i = 0; i<seq_no; i++)
                    _missingNm[i] = '0';
            }else{
                for (int i = 0; i<seq_no; i++) {        //받은 seq_no만큼만 데이터 확인
                    byte[] data = (byte[]) block_data.get( new Integer(i) );
                    if (data == null ) {
                        _missingNm[i] = '0';    //결번이 발생한 seq만 '0' 설정
                        MISSING_COUNT++;
                        logger.info("{} calculateMissingCount >> missing telegram : [" + i + "]", logHeader);
                    }
                }
            }

            if (MISSING_COUNT == 0) {
                if (!createFile()) {
                    return false;
                }

                for (int i = 0; i<seq_no; i++) {        //받은 seq_no만큼만 데이터 확인하여 기록
                    byte[] data = (byte[]) block_data.get(new Integer(i));
                    int recLen = batchDoc.getBatchMsg().getHeader().getRecLen();
                    if ( recLen < 1 ){
                    	recLen = data.length;
                    }
                    byte[]layout = new byte[recLen];
                    for (int inx = 0; inx < layout.length; inx++) {
                        layout[inx] = ' ';
                    }

                    int dataCnt = data.length / recLen ;
                    for (int jnx = 0; jnx < dataCnt; jnx++) {
                        System.arraycopy( data,jnx*layout.length,layout,0,layout.length);
                        fout.write(layout);
                        fout.write( '\n' );
                        long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize()+recLen;
                        batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);
                    }

                }
                hm.put(JobProcessData.PROCDATA_BLOCKDATA, null);    //데이터 기록후 HashMap 초기화
            }

            this.MISSING_FIELD = new String (_missingNm);
            this.batchDoc.getBatchMsg().getBody().setMissingNmCount(MISSING_COUNT);
            this.batchDoc.getBatchMsg().getBody().setMissingNmField(MISSING_FIELD);

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI027";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    private boolean createFile () {
        try {
            String strFullPath = batchDoc.getBatchMsg().getHeader().getFilePath();
            if (strFullPath.charAt(strFullPath.length()-1) != File.separatorChar) {
                strFullPath = strFullPath + File.separator;
            }
            strFullPath = strFullPath + batchDoc.getBatchMsg().getHeader().getFileName();
            logger.info("{}  getCalculatedLength >> File full-path [" + strFullPath + "]", logHeader);
            file = new File(strFullPath);
            fout = new FileOutputStream(file, true);   //bytes will be written to the end of the file rather than the beginning
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(10);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(7);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}
